# coding: utf-8

"""
    Snowstorm

    SNOMED CT Terminology Server REST API

    The version of the OpenAPI document: 10.8.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import Field, StrictBool, StrictInt, StrictStr
from typing import List, Optional
from typing_extensions import Annotated
from snowstorm_client.models.async_refset_member_change_batch import AsyncRefsetMemberChangeBatch
from snowstorm_client.models.items_page_reference_set_member_component import ItemsPageReferenceSetMemberComponent
from snowstorm_client.models.ref_set_member_page_with_bucket_aggregations_reference_set_member import RefSetMemberPageWithBucketAggregationsReferenceSetMember
from snowstorm_client.models.reference_set_member_component import ReferenceSetMemberComponent

from snowstorm_client.api_client import ApiClient, RequestSerialized
from snowstorm_client.api_response import ApiResponse
from snowstorm_client.rest import RESTResponseType


class RefsetMembersApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def fetch_member(
        self,
        branch: StrictStr,
        uuid: StrictStr,
        accept_language: Optional[StrictStr] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ReferenceSetMemberComponent:
        """fetch_member


        :param branch: (required)
        :type branch: str
        :param uuid: (required)
        :type uuid: str
        :param accept_language:
        :type accept_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._fetch_member_serialize(
            branch=branch,
            uuid=uuid,
            accept_language=accept_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "ReferenceSetMemberComponent",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def fetch_member_with_http_info(
        self,
        branch: StrictStr,
        uuid: StrictStr,
        accept_language: Optional[StrictStr] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[ReferenceSetMemberComponent]:
        """fetch_member


        :param branch: (required)
        :type branch: str
        :param uuid: (required)
        :type uuid: str
        :param accept_language:
        :type accept_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._fetch_member_serialize(
            branch=branch,
            uuid=uuid,
            accept_language=accept_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "ReferenceSetMemberComponent",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def fetch_member_without_preload_content(
        self,
        branch: StrictStr,
        uuid: StrictStr,
        accept_language: Optional[StrictStr] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """fetch_member


        :param branch: (required)
        :type branch: str
        :param uuid: (required)
        :type uuid: str
        :param accept_language:
        :type accept_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._fetch_member_serialize(
            branch=branch,
            uuid=uuid,
            accept_language=accept_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "ReferenceSetMemberComponent",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _fetch_member_serialize(
        self,
        branch,
        uuid,
        accept_language,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if branch is not None:
            _path_params['branch'] = branch
        if uuid is not None:
            _path_params['uuid'] = uuid
        # process the query parameters
        # process the header parameters
        if accept_language is not None:
            _header_params['Accept-Language'] = accept_language
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/{branch}/members/{uuid}',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def find_browser_reference_set_members_with_aggregations(
        self,
        branch: StrictStr,
        reference_set: Annotated[Optional[StrictStr], Field(description="A reference set identifier or ECL expression can be used to limit the reference sets searched. Example: <723564002")] = None,
        module: Annotated[Optional[StrictStr], Field(description="A concept identifier or ECL expression can be used to limit the modules searched. Example: <900000000000445007")] = None,
        referenced_component_id: Annotated[Optional[List[StrictStr]], Field(description="Set of referencedComponentId ids to limit search")] = None,
        active: Optional[StrictBool] = None,
        offset: Optional[StrictInt] = None,
        limit: Optional[StrictInt] = None,
        search_after: Optional[StrictStr] = None,
        accept_language: Optional[StrictStr] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RefSetMemberPageWithBucketAggregationsReferenceSetMember:
        """find_browser_reference_set_members_with_aggregations

        Search for reference set ids.

        :param branch: (required)
        :type branch: str
        :param reference_set: A reference set identifier or ECL expression can be used to limit the reference sets searched. Example: <723564002
        :type reference_set: str
        :param module: A concept identifier or ECL expression can be used to limit the modules searched. Example: <900000000000445007
        :type module: str
        :param referenced_component_id: Set of referencedComponentId ids to limit search
        :type referenced_component_id: List[str]
        :param active:
        :type active: bool
        :param offset:
        :type offset: int
        :param limit:
        :type limit: int
        :param search_after:
        :type search_after: str
        :param accept_language:
        :type accept_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._find_browser_reference_set_members_with_aggregations_serialize(
            branch=branch,
            reference_set=reference_set,
            module=module,
            referenced_component_id=referenced_component_id,
            active=active,
            offset=offset,
            limit=limit,
            search_after=search_after,
            accept_language=accept_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "RefSetMemberPageWithBucketAggregationsReferenceSetMember",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def find_browser_reference_set_members_with_aggregations_with_http_info(
        self,
        branch: StrictStr,
        reference_set: Annotated[Optional[StrictStr], Field(description="A reference set identifier or ECL expression can be used to limit the reference sets searched. Example: <723564002")] = None,
        module: Annotated[Optional[StrictStr], Field(description="A concept identifier or ECL expression can be used to limit the modules searched. Example: <900000000000445007")] = None,
        referenced_component_id: Annotated[Optional[List[StrictStr]], Field(description="Set of referencedComponentId ids to limit search")] = None,
        active: Optional[StrictBool] = None,
        offset: Optional[StrictInt] = None,
        limit: Optional[StrictInt] = None,
        search_after: Optional[StrictStr] = None,
        accept_language: Optional[StrictStr] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[RefSetMemberPageWithBucketAggregationsReferenceSetMember]:
        """find_browser_reference_set_members_with_aggregations

        Search for reference set ids.

        :param branch: (required)
        :type branch: str
        :param reference_set: A reference set identifier or ECL expression can be used to limit the reference sets searched. Example: <723564002
        :type reference_set: str
        :param module: A concept identifier or ECL expression can be used to limit the modules searched. Example: <900000000000445007
        :type module: str
        :param referenced_component_id: Set of referencedComponentId ids to limit search
        :type referenced_component_id: List[str]
        :param active:
        :type active: bool
        :param offset:
        :type offset: int
        :param limit:
        :type limit: int
        :param search_after:
        :type search_after: str
        :param accept_language:
        :type accept_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._find_browser_reference_set_members_with_aggregations_serialize(
            branch=branch,
            reference_set=reference_set,
            module=module,
            referenced_component_id=referenced_component_id,
            active=active,
            offset=offset,
            limit=limit,
            search_after=search_after,
            accept_language=accept_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "RefSetMemberPageWithBucketAggregationsReferenceSetMember",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def find_browser_reference_set_members_with_aggregations_without_preload_content(
        self,
        branch: StrictStr,
        reference_set: Annotated[Optional[StrictStr], Field(description="A reference set identifier or ECL expression can be used to limit the reference sets searched. Example: <723564002")] = None,
        module: Annotated[Optional[StrictStr], Field(description="A concept identifier or ECL expression can be used to limit the modules searched. Example: <900000000000445007")] = None,
        referenced_component_id: Annotated[Optional[List[StrictStr]], Field(description="Set of referencedComponentId ids to limit search")] = None,
        active: Optional[StrictBool] = None,
        offset: Optional[StrictInt] = None,
        limit: Optional[StrictInt] = None,
        search_after: Optional[StrictStr] = None,
        accept_language: Optional[StrictStr] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """find_browser_reference_set_members_with_aggregations

        Search for reference set ids.

        :param branch: (required)
        :type branch: str
        :param reference_set: A reference set identifier or ECL expression can be used to limit the reference sets searched. Example: <723564002
        :type reference_set: str
        :param module: A concept identifier or ECL expression can be used to limit the modules searched. Example: <900000000000445007
        :type module: str
        :param referenced_component_id: Set of referencedComponentId ids to limit search
        :type referenced_component_id: List[str]
        :param active:
        :type active: bool
        :param offset:
        :type offset: int
        :param limit:
        :type limit: int
        :param search_after:
        :type search_after: str
        :param accept_language:
        :type accept_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._find_browser_reference_set_members_with_aggregations_serialize(
            branch=branch,
            reference_set=reference_set,
            module=module,
            referenced_component_id=referenced_component_id,
            active=active,
            offset=offset,
            limit=limit,
            search_after=search_after,
            accept_language=accept_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "RefSetMemberPageWithBucketAggregationsReferenceSetMember",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _find_browser_reference_set_members_with_aggregations_serialize(
        self,
        branch,
        reference_set,
        module,
        referenced_component_id,
        active,
        offset,
        limit,
        search_after,
        accept_language,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
            'referencedComponentId': 'multi',
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if branch is not None:
            _path_params['branch'] = branch
        # process the query parameters
        if reference_set is not None:
            
            _query_params.append(('referenceSet', reference_set))
            
        if module is not None:
            
            _query_params.append(('module', module))
            
        if referenced_component_id is not None:
            
            _query_params.append(('referencedComponentId', referenced_component_id))
            
        if active is not None:
            
            _query_params.append(('active', active))
            
        if offset is not None:
            
            _query_params.append(('offset', offset))
            
        if limit is not None:
            
            _query_params.append(('limit', limit))
            
        if search_after is not None:
            
            _query_params.append(('searchAfter', search_after))
            
        # process the header parameters
        if accept_language is not None:
            _header_params['Accept-Language'] = accept_language
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/browser/{branch}/members',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def find_refset_members(
        self,
        branch: StrictStr,
        reference_set: Annotated[Optional[StrictStr], Field(description="A reference set identifier or ECL expression can be used to limit the reference sets searched. Example: <723564002")] = None,
        module: Annotated[Optional[StrictStr], Field(description="A concept identifier or ECL expression can be used to limit the modules searched. Example: <900000000000445007")] = None,
        referenced_component_id: Annotated[Optional[List[StrictStr]], Field(description="Set of referencedComponentId ids to limit search")] = None,
        active: Optional[StrictBool] = None,
        is_null_effective_time: Optional[StrictBool] = None,
        target_component: Annotated[Optional[List[StrictStr]], Field(description="Set of target component ids to limit search")] = None,
        map_target: Optional[StrictStr] = None,
        owl_expression_concept_id: Annotated[Optional[StrictStr], Field(description="Search by concept identifiers within an owlExpression.")] = None,
        owl_expression_gci: Annotated[Optional[StrictBool], Field(description="Return axiom members with a GCI owlExpression.")] = None,
        offset: Optional[StrictInt] = None,
        limit: Optional[StrictInt] = None,
        search_after: Optional[StrictStr] = None,
        accept_language: Optional[StrictStr] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ItemsPageReferenceSetMemberComponent:
        """Search for reference set members.


        :param branch: (required)
        :type branch: str
        :param reference_set: A reference set identifier or ECL expression can be used to limit the reference sets searched. Example: <723564002
        :type reference_set: str
        :param module: A concept identifier or ECL expression can be used to limit the modules searched. Example: <900000000000445007
        :type module: str
        :param referenced_component_id: Set of referencedComponentId ids to limit search
        :type referenced_component_id: List[str]
        :param active:
        :type active: bool
        :param is_null_effective_time:
        :type is_null_effective_time: bool
        :param target_component: Set of target component ids to limit search
        :type target_component: List[str]
        :param map_target:
        :type map_target: str
        :param owl_expression_concept_id: Search by concept identifiers within an owlExpression.
        :type owl_expression_concept_id: str
        :param owl_expression_gci: Return axiom members with a GCI owlExpression.
        :type owl_expression_gci: bool
        :param offset:
        :type offset: int
        :param limit:
        :type limit: int
        :param search_after:
        :type search_after: str
        :param accept_language:
        :type accept_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._find_refset_members_serialize(
            branch=branch,
            reference_set=reference_set,
            module=module,
            referenced_component_id=referenced_component_id,
            active=active,
            is_null_effective_time=is_null_effective_time,
            target_component=target_component,
            map_target=map_target,
            owl_expression_concept_id=owl_expression_concept_id,
            owl_expression_gci=owl_expression_gci,
            offset=offset,
            limit=limit,
            search_after=search_after,
            accept_language=accept_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "ItemsPageReferenceSetMemberComponent",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def find_refset_members_with_http_info(
        self,
        branch: StrictStr,
        reference_set: Annotated[Optional[StrictStr], Field(description="A reference set identifier or ECL expression can be used to limit the reference sets searched. Example: <723564002")] = None,
        module: Annotated[Optional[StrictStr], Field(description="A concept identifier or ECL expression can be used to limit the modules searched. Example: <900000000000445007")] = None,
        referenced_component_id: Annotated[Optional[List[StrictStr]], Field(description="Set of referencedComponentId ids to limit search")] = None,
        active: Optional[StrictBool] = None,
        is_null_effective_time: Optional[StrictBool] = None,
        target_component: Annotated[Optional[List[StrictStr]], Field(description="Set of target component ids to limit search")] = None,
        map_target: Optional[StrictStr] = None,
        owl_expression_concept_id: Annotated[Optional[StrictStr], Field(description="Search by concept identifiers within an owlExpression.")] = None,
        owl_expression_gci: Annotated[Optional[StrictBool], Field(description="Return axiom members with a GCI owlExpression.")] = None,
        offset: Optional[StrictInt] = None,
        limit: Optional[StrictInt] = None,
        search_after: Optional[StrictStr] = None,
        accept_language: Optional[StrictStr] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[ItemsPageReferenceSetMemberComponent]:
        """Search for reference set members.


        :param branch: (required)
        :type branch: str
        :param reference_set: A reference set identifier or ECL expression can be used to limit the reference sets searched. Example: <723564002
        :type reference_set: str
        :param module: A concept identifier or ECL expression can be used to limit the modules searched. Example: <900000000000445007
        :type module: str
        :param referenced_component_id: Set of referencedComponentId ids to limit search
        :type referenced_component_id: List[str]
        :param active:
        :type active: bool
        :param is_null_effective_time:
        :type is_null_effective_time: bool
        :param target_component: Set of target component ids to limit search
        :type target_component: List[str]
        :param map_target:
        :type map_target: str
        :param owl_expression_concept_id: Search by concept identifiers within an owlExpression.
        :type owl_expression_concept_id: str
        :param owl_expression_gci: Return axiom members with a GCI owlExpression.
        :type owl_expression_gci: bool
        :param offset:
        :type offset: int
        :param limit:
        :type limit: int
        :param search_after:
        :type search_after: str
        :param accept_language:
        :type accept_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._find_refset_members_serialize(
            branch=branch,
            reference_set=reference_set,
            module=module,
            referenced_component_id=referenced_component_id,
            active=active,
            is_null_effective_time=is_null_effective_time,
            target_component=target_component,
            map_target=map_target,
            owl_expression_concept_id=owl_expression_concept_id,
            owl_expression_gci=owl_expression_gci,
            offset=offset,
            limit=limit,
            search_after=search_after,
            accept_language=accept_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "ItemsPageReferenceSetMemberComponent",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def find_refset_members_without_preload_content(
        self,
        branch: StrictStr,
        reference_set: Annotated[Optional[StrictStr], Field(description="A reference set identifier or ECL expression can be used to limit the reference sets searched. Example: <723564002")] = None,
        module: Annotated[Optional[StrictStr], Field(description="A concept identifier or ECL expression can be used to limit the modules searched. Example: <900000000000445007")] = None,
        referenced_component_id: Annotated[Optional[List[StrictStr]], Field(description="Set of referencedComponentId ids to limit search")] = None,
        active: Optional[StrictBool] = None,
        is_null_effective_time: Optional[StrictBool] = None,
        target_component: Annotated[Optional[List[StrictStr]], Field(description="Set of target component ids to limit search")] = None,
        map_target: Optional[StrictStr] = None,
        owl_expression_concept_id: Annotated[Optional[StrictStr], Field(description="Search by concept identifiers within an owlExpression.")] = None,
        owl_expression_gci: Annotated[Optional[StrictBool], Field(description="Return axiom members with a GCI owlExpression.")] = None,
        offset: Optional[StrictInt] = None,
        limit: Optional[StrictInt] = None,
        search_after: Optional[StrictStr] = None,
        accept_language: Optional[StrictStr] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Search for reference set members.


        :param branch: (required)
        :type branch: str
        :param reference_set: A reference set identifier or ECL expression can be used to limit the reference sets searched. Example: <723564002
        :type reference_set: str
        :param module: A concept identifier or ECL expression can be used to limit the modules searched. Example: <900000000000445007
        :type module: str
        :param referenced_component_id: Set of referencedComponentId ids to limit search
        :type referenced_component_id: List[str]
        :param active:
        :type active: bool
        :param is_null_effective_time:
        :type is_null_effective_time: bool
        :param target_component: Set of target component ids to limit search
        :type target_component: List[str]
        :param map_target:
        :type map_target: str
        :param owl_expression_concept_id: Search by concept identifiers within an owlExpression.
        :type owl_expression_concept_id: str
        :param owl_expression_gci: Return axiom members with a GCI owlExpression.
        :type owl_expression_gci: bool
        :param offset:
        :type offset: int
        :param limit:
        :type limit: int
        :param search_after:
        :type search_after: str
        :param accept_language:
        :type accept_language: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._find_refset_members_serialize(
            branch=branch,
            reference_set=reference_set,
            module=module,
            referenced_component_id=referenced_component_id,
            active=active,
            is_null_effective_time=is_null_effective_time,
            target_component=target_component,
            map_target=map_target,
            owl_expression_concept_id=owl_expression_concept_id,
            owl_expression_gci=owl_expression_gci,
            offset=offset,
            limit=limit,
            search_after=search_after,
            accept_language=accept_language,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "ItemsPageReferenceSetMemberComponent",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _find_refset_members_serialize(
        self,
        branch,
        reference_set,
        module,
        referenced_component_id,
        active,
        is_null_effective_time,
        target_component,
        map_target,
        owl_expression_concept_id,
        owl_expression_gci,
        offset,
        limit,
        search_after,
        accept_language,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
            'referencedComponentId': 'multi',
            'targetComponent': 'multi',
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if branch is not None:
            _path_params['branch'] = branch
        # process the query parameters
        if reference_set is not None:
            
            _query_params.append(('referenceSet', reference_set))
            
        if module is not None:
            
            _query_params.append(('module', module))
            
        if referenced_component_id is not None:
            
            _query_params.append(('referencedComponentId', referenced_component_id))
            
        if active is not None:
            
            _query_params.append(('active', active))
            
        if is_null_effective_time is not None:
            
            _query_params.append(('isNullEffectiveTime', is_null_effective_time))
            
        if target_component is not None:
            
            _query_params.append(('targetComponent', target_component))
            
        if map_target is not None:
            
            _query_params.append(('mapTarget', map_target))
            
        if owl_expression_concept_id is not None:
            
            _query_params.append(('owlExpression.conceptId', owl_expression_concept_id))
            
        if owl_expression_gci is not None:
            
            _query_params.append(('owlExpression.gci', owl_expression_gci))
            
        if offset is not None:
            
            _query_params.append(('offset', offset))
            
        if limit is not None:
            
            _query_params.append(('limit', limit))
            
        if search_after is not None:
            
            _query_params.append(('searchAfter', search_after))
            
        # process the header parameters
        if accept_language is not None:
            _header_params['Accept-Language'] = accept_language
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/{branch}/members',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def get_member_bulk_change(
        self,
        branch: StrictStr,
        bulk_change_id: StrictStr,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> AsyncRefsetMemberChangeBatch:
        """Fetch the status of a bulk reference set member create/update job.


        :param branch: (required)
        :type branch: str
        :param bulk_change_id: (required)
        :type bulk_change_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_member_bulk_change_serialize(
            branch=branch,
            bulk_change_id=bulk_change_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "AsyncRefsetMemberChangeBatch",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def get_member_bulk_change_with_http_info(
        self,
        branch: StrictStr,
        bulk_change_id: StrictStr,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[AsyncRefsetMemberChangeBatch]:
        """Fetch the status of a bulk reference set member create/update job.


        :param branch: (required)
        :type branch: str
        :param bulk_change_id: (required)
        :type bulk_change_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_member_bulk_change_serialize(
            branch=branch,
            bulk_change_id=bulk_change_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "AsyncRefsetMemberChangeBatch",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def get_member_bulk_change_without_preload_content(
        self,
        branch: StrictStr,
        bulk_change_id: StrictStr,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Fetch the status of a bulk reference set member create/update job.


        :param branch: (required)
        :type branch: str
        :param bulk_change_id: (required)
        :type bulk_change_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_member_bulk_change_serialize(
            branch=branch,
            bulk_change_id=bulk_change_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "AsyncRefsetMemberChangeBatch",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _get_member_bulk_change_serialize(
        self,
        branch,
        bulk_change_id,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if branch is not None:
            _path_params['branch'] = branch
        if bulk_change_id is not None:
            _path_params['bulkChangeId'] = bulk_change_id
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/{branch}/members/bulk/{bulkChangeId}',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )


