# coding: utf-8

"""
    Snowstorm

    SNOMED CT Terminology Server REST API

    The version of the OpenAPI document: 10.8.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class AsyncRefsetMemberChangeBatch(BaseModel):
    """
    AsyncRefsetMemberChangeBatch
    """ # noqa: E501
    id: Optional[StrictStr] = None
    start_time: Optional[datetime] = Field(default=None, alias="startTime")
    status: Optional[StrictStr] = None
    member_ids: Optional[List[StrictStr]] = Field(default=None, alias="memberIds")
    end_time: Optional[datetime] = Field(default=None, alias="endTime")
    message: Optional[StrictStr] = None
    seconds_duration: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="secondsDuration")
    __properties: ClassVar[List[str]] = ["id", "startTime", "status", "memberIds", "endTime", "message", "secondsDuration"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['RUNNING', 'COMPLETED', 'FAILED']):
            raise ValueError("must be one of enum values ('RUNNING', 'COMPLETED', 'FAILED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AsyncRefsetMemberChangeBatch from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AsyncRefsetMemberChangeBatch from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "startTime": obj.get("startTime"),
            "status": obj.get("status"),
            "memberIds": obj.get("memberIds"),
            "endTime": obj.get("endTime"),
            "message": obj.get("message"),
            "secondsDuration": obj.get("secondsDuration")
        })
        return _obj


