# coding: utf-8

"""
    Snowstorm

    SNOMED CT Terminology Server REST API

    The version of the OpenAPI document: 10.8.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AuthoringStatsSummary(BaseModel):
    """
    AuthoringStatsSummary
    """ # noqa: E501
    new_concepts_count: Optional[StrictInt] = Field(default=None, alias="newConceptsCount")
    inactivated_concepts_count: Optional[StrictInt] = Field(default=None, alias="inactivatedConceptsCount")
    reactivated_concepts_count: Optional[StrictInt] = Field(default=None, alias="reactivatedConceptsCount")
    changed_fsn_count: Optional[StrictInt] = Field(default=None, alias="changedFsnCount")
    inactivated_synonyms_count: Optional[StrictInt] = Field(default=None, alias="inactivatedSynonymsCount")
    new_synonyms_for_existing_concepts_count: Optional[StrictInt] = Field(default=None, alias="newSynonymsForExistingConceptsCount")
    reactivated_synonyms_count: Optional[StrictInt] = Field(default=None, alias="reactivatedSynonymsCount")
    execution_time: Optional[datetime] = Field(default=None, alias="executionTime")
    title: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["newConceptsCount", "inactivatedConceptsCount", "reactivatedConceptsCount", "changedFsnCount", "inactivatedSynonymsCount", "newSynonymsForExistingConceptsCount", "reactivatedSynonymsCount", "executionTime", "title"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AuthoringStatsSummary from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AuthoringStatsSummary from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "newConceptsCount": obj.get("newConceptsCount"),
            "inactivatedConceptsCount": obj.get("inactivatedConceptsCount"),
            "reactivatedConceptsCount": obj.get("reactivatedConceptsCount"),
            "changedFsnCount": obj.get("changedFsnCount"),
            "inactivatedSynonymsCount": obj.get("inactivatedSynonymsCount"),
            "newSynonymsForExistingConceptsCount": obj.get("newSynonymsForExistingConceptsCount"),
            "reactivatedSynonymsCount": obj.get("reactivatedSynonymsCount"),
            "executionTime": obj.get("executionTime"),
            "title": obj.get("title")
        })
        return _obj


