# coding: utf-8

"""
    Snowstorm

    SNOMED CT Terminology Server REST API

    The version of the OpenAPI document: 10.8.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from snowstorm_client.models.relationship_component import RelationshipComponent
from typing import Optional, Set
from typing_extensions import Self

class AxiomComponent(BaseModel):
    """
    AxiomComponent
    """ # noqa: E501
    axiom_id: Optional[StrictStr] = Field(default=None, alias="axiomId")
    module_id: Optional[StrictStr] = Field(default=None, alias="moduleId")
    active: Optional[StrictBool] = None
    released: Optional[StrictBool] = None
    definition_status_id: Optional[StrictStr] = Field(default=None, alias="definitionStatusId")
    relationships: Optional[List[RelationshipComponent]] = None
    id: Optional[StrictStr] = None
    definition_status: Optional[StrictStr] = Field(default=None, alias="definitionStatus")
    effective_time: Optional[StrictInt] = Field(default=None, alias="effectiveTime")
    __properties: ClassVar[List[str]] = ["axiomId", "moduleId", "active", "released", "definitionStatusId", "relationships", "id", "definitionStatus", "effectiveTime"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AxiomComponent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in relationships (list)
        _items = []
        if self.relationships:
            for _item_relationships in self.relationships:
                if _item_relationships:
                    _items.append(_item_relationships.to_dict())
            _dict['relationships'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AxiomComponent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "axiomId": obj.get("axiomId"),
            "moduleId": obj.get("moduleId"),
            "active": obj.get("active"),
            "released": obj.get("released"),
            "definitionStatusId": obj.get("definitionStatusId"),
            "relationships": [RelationshipComponent.from_dict(_item) for _item in obj["relationships"]] if obj.get("relationships") is not None else None,
            "id": obj.get("id"),
            "definitionStatus": obj.get("definitionStatus"),
            "effectiveTime": obj.get("effectiveTime")
        })
        return _obj


