# coding: utf-8

"""
    Snowstorm

    SNOMED CT Terminology Server REST API

    The version of the OpenAPI document: 10.8.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class BranchPojo(BaseModel):
    """
    BranchPojo
    """ # noqa: E501
    path: Optional[StrictStr] = None
    state: Optional[StrictStr] = None
    contains_content: Optional[StrictBool] = Field(default=None, alias="containsContent")
    locked: Optional[StrictBool] = None
    creation: Optional[datetime] = None
    base: Optional[datetime] = None
    head: Optional[datetime] = None
    creation_timestamp: Optional[StrictInt] = Field(default=None, alias="creationTimestamp")
    base_timestamp: Optional[StrictInt] = Field(default=None, alias="baseTimestamp")
    head_timestamp: Optional[StrictInt] = Field(default=None, alias="headTimestamp")
    user_roles: Optional[List[StrictStr]] = Field(default=None, alias="userRoles")
    global_user_roles: Optional[List[StrictStr]] = Field(default=None, alias="globalUserRoles")
    versions_replaced_counts: Optional[Dict[str, StrictInt]] = Field(default=None, alias="versionsReplacedCounts")
    metadata: Optional[Dict[str, Dict[str, Any]]] = None
    versions_replaced: Optional[Dict[str, List[StrictStr]]] = Field(default=None, alias="versionsReplaced")
    __properties: ClassVar[List[str]] = ["path", "state", "containsContent", "locked", "creation", "base", "head", "creationTimestamp", "baseTimestamp", "headTimestamp", "userRoles", "globalUserRoles", "versionsReplacedCounts", "metadata", "versionsReplaced"]

    @field_validator('state')
    def state_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['UP_TO_DATE', 'FORWARD', 'BEHIND', 'DIVERGED']):
            raise ValueError("must be one of enum values ('UP_TO_DATE', 'FORWARD', 'BEHIND', 'DIVERGED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BranchPojo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BranchPojo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "path": obj.get("path"),
            "state": obj.get("state"),
            "containsContent": obj.get("containsContent"),
            "locked": obj.get("locked"),
            "creation": obj.get("creation"),
            "base": obj.get("base"),
            "head": obj.get("head"),
            "creationTimestamp": obj.get("creationTimestamp"),
            "baseTimestamp": obj.get("baseTimestamp"),
            "headTimestamp": obj.get("headTimestamp"),
            "userRoles": obj.get("userRoles"),
            "globalUserRoles": obj.get("globalUserRoles"),
            "versionsReplacedCounts": obj.get("versionsReplacedCounts"),
            "metadata": obj.get("metadata"),
            "versionsReplaced": obj.get("versionsReplaced")
        })
        return _obj


