# coding: utf-8

"""
    Snowstorm

    SNOMED CT Terminology Server REST API

    The version of the OpenAPI document: 10.8.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from snowstorm_client.models.branch_state import BranchState
from typing import Optional, Set
from typing_extensions import Self

class BranchReview(BaseModel):
    """
    BranchReview
    """ # noqa: E501
    id: StrictStr
    last_updated: Optional[datetime] = Field(default=None, alias="lastUpdated")
    status: Optional[StrictStr] = None
    source: Optional[BranchState] = None
    target: Optional[BranchState] = None
    changed_concepts: Optional[List[StrictInt]] = Field(default=None, alias="changedConcepts")
    source_parent: Optional[StrictBool] = Field(default=None, alias="sourceParent")
    __properties: ClassVar[List[str]] = ["id", "lastUpdated", "status", "source", "target", "changedConcepts", "sourceParent"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['PENDING', 'CURRENT', 'STALE', 'FAILED']):
            raise ValueError("must be one of enum values ('PENDING', 'CURRENT', 'STALE', 'FAILED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BranchReview from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of source
        if self.source:
            _dict['source'] = self.source.to_dict()
        # override the default output from pydantic by calling `to_dict()` of target
        if self.target:
            _dict['target'] = self.target.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BranchReview from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "lastUpdated": obj.get("lastUpdated"),
            "status": obj.get("status"),
            "source": BranchState.from_dict(obj["source"]) if obj.get("source") is not None else None,
            "target": BranchState.from_dict(obj["target"]) if obj.get("target") is not None else None,
            "changedConcepts": obj.get("changedConcepts"),
            "sourceParent": obj.get("sourceParent")
        })
        return _obj


