# coding: utf-8

"""
    Snowstorm

    SNOMED CT Terminology Server REST API

    The version of the OpenAPI document: 10.8.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from snowstorm_client.models.concept_mini_component import ConceptMiniComponent
from snowstorm_client.models.snomed_component_object_component import SnomedComponentObjectComponent
from typing import Optional, Set
from typing_extensions import Self

class IdentifierComponent(BaseModel):
    """
    IdentifierComponent
    """ # noqa: E501
    alternate_identifier: StrictStr = Field(alias="alternateIdentifier")
    effective_time: Optional[StrictStr] = Field(default=None, alias="effectiveTime")
    active: Optional[StrictBool] = None
    module_id: Optional[Annotated[str, Field(min_length=5, strict=True, max_length=18)]] = Field(default=None, alias="moduleId")
    identifier_scheme_id: Annotated[str, Field(min_length=5, strict=True, max_length=18)] = Field(alias="identifierSchemeId")
    identifier_scheme: Optional[ConceptMiniComponent] = Field(default=None, alias="identifierScheme")
    referenced_component_id: Annotated[str, Field(min_length=5, strict=True, max_length=18)] = Field(alias="referencedComponentId")
    released: Optional[StrictBool] = None
    released_effective_time: Optional[StrictInt] = Field(default=None, alias="releasedEffectiveTime")
    internal_id: Optional[StrictStr] = Field(default=None, alias="internalId")
    path: Optional[StrictStr] = None
    start: Optional[datetime] = None
    end: Optional[datetime] = None
    deleted: Optional[StrictBool] = None
    changed: Optional[StrictBool] = None
    effective_time_i: Optional[StrictInt] = Field(default=None, alias="effectiveTimeI")
    release_hash: Optional[StrictStr] = Field(default=None, alias="releaseHash")
    referenced_component_snomed_component: Optional[SnomedComponentObjectComponent] = Field(default=None, alias="referencedComponentSnomedComponent")
    id: Optional[StrictStr] = None
    referenced_component: Optional[Dict[str, Any]] = Field(default=None, alias="referencedComponent")
    __properties: ClassVar[List[str]] = ["alternateIdentifier", "effectiveTime", "active", "moduleId", "identifierSchemeId", "identifierScheme", "referencedComponentId", "released", "releasedEffectiveTime", "internalId", "path", "start", "end", "deleted", "changed", "effectiveTimeI", "releaseHash", "referencedComponentSnomedComponent", "id", "referencedComponent"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of IdentifierComponent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of identifier_scheme
        if self.identifier_scheme:
            _dict['identifierScheme'] = self.identifier_scheme.to_dict()
        # override the default output from pydantic by calling `to_dict()` of referenced_component_snomed_component
        if self.referenced_component_snomed_component:
            _dict['referencedComponentSnomedComponent'] = self.referenced_component_snomed_component.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of IdentifierComponent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "alternateIdentifier": obj.get("alternateIdentifier"),
            "effectiveTime": obj.get("effectiveTime"),
            "active": obj.get("active"),
            "moduleId": obj.get("moduleId"),
            "identifierSchemeId": obj.get("identifierSchemeId"),
            "identifierScheme": ConceptMiniComponent.from_dict(obj["identifierScheme"]) if obj.get("identifierScheme") is not None else None,
            "referencedComponentId": obj.get("referencedComponentId"),
            "released": obj.get("released"),
            "releasedEffectiveTime": obj.get("releasedEffectiveTime"),
            "internalId": obj.get("internalId"),
            "path": obj.get("path"),
            "start": obj.get("start"),
            "end": obj.get("end"),
            "deleted": obj.get("deleted"),
            "changed": obj.get("changed"),
            "effectiveTimeI": obj.get("effectiveTimeI"),
            "releaseHash": obj.get("releaseHash"),
            "referencedComponentSnomedComponent": SnomedComponentObjectComponent.from_dict(obj["referencedComponentSnomedComponent"]) if obj.get("referencedComponentSnomedComponent") is not None else None,
            "id": obj.get("id"),
            "referencedComponent": obj.get("referencedComponent")
        })
        return _obj


