# coding: utf-8

"""
    Snowstorm

    SNOMED CT Terminology Server REST API

    The version of the OpenAPI document: 10.8.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from snowstorm_client.models.concept import Concept
from typing import Optional, Set
from typing_extensions import Self

class MergeReviewConceptVersions(BaseModel):
    """
    MergeReviewConceptVersions
    """ # noqa: E501
    source_concept: Optional[Concept] = Field(default=None, alias="sourceConcept")
    target_concept: Optional[Concept] = Field(default=None, alias="targetConcept")
    auto_merged_concept: Optional[Concept] = Field(default=None, alias="autoMergedConcept")
    manually_merged_concept: Optional[Concept] = Field(default=None, alias="manuallyMergedConcept")
    target_concept_version_behind: Optional[StrictBool] = Field(default=None, alias="targetConceptVersionBehind")
    __properties: ClassVar[List[str]] = ["sourceConcept", "targetConcept", "autoMergedConcept", "manuallyMergedConcept", "targetConceptVersionBehind"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MergeReviewConceptVersions from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of source_concept
        if self.source_concept:
            _dict['sourceConcept'] = self.source_concept.to_dict()
        # override the default output from pydantic by calling `to_dict()` of target_concept
        if self.target_concept:
            _dict['targetConcept'] = self.target_concept.to_dict()
        # override the default output from pydantic by calling `to_dict()` of auto_merged_concept
        if self.auto_merged_concept:
            _dict['autoMergedConcept'] = self.auto_merged_concept.to_dict()
        # override the default output from pydantic by calling `to_dict()` of manually_merged_concept
        if self.manually_merged_concept:
            _dict['manuallyMergedConcept'] = self.manually_merged_concept.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MergeReviewConceptVersions from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sourceConcept": Concept.from_dict(obj["sourceConcept"]) if obj.get("sourceConcept") is not None else None,
            "targetConcept": Concept.from_dict(obj["targetConcept"]) if obj.get("targetConcept") is not None else None,
            "autoMergedConcept": Concept.from_dict(obj["autoMergedConcept"]) if obj.get("autoMergedConcept") is not None else None,
            "manuallyMergedConcept": Concept.from_dict(obj["manuallyMergedConcept"]) if obj.get("manuallyMergedConcept") is not None else None,
            "targetConceptVersionBehind": obj.get("targetConceptVersionBehind")
        })
        return _obj


