# coding: utf-8

"""
    Snowstorm

    SNOMED CT Terminology Server REST API

    The version of the OpenAPI document: 10.8.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from snowstorm_client.models.concept_mini import ConceptMini
from snowstorm_client.models.concrete_value import ConcreteValue
from typing import Optional, Set
from typing_extensions import Self

class Relationship(BaseModel):
    """
    Relationship
    """ # noqa: E501
    internal_id: Optional[StrictStr] = Field(default=None, alias="internalId")
    path: Optional[StrictStr] = None
    start: Optional[datetime] = None
    end: Optional[datetime] = None
    deleted: Optional[StrictBool] = None
    changed: Optional[StrictBool] = None
    active: Optional[StrictBool] = None
    module_id: Optional[Annotated[str, Field(min_length=5, strict=True, max_length=18)]] = Field(default=None, alias="moduleId")
    effective_time_i: Optional[StrictInt] = Field(default=None, alias="effectiveTimeI")
    released: Optional[StrictBool] = None
    release_hash: Optional[StrictStr] = Field(default=None, alias="releaseHash")
    released_effective_time: Optional[StrictInt] = Field(default=None, alias="releasedEffectiveTime")
    relationship_id: Optional[StrictStr] = Field(default=None, alias="relationshipId")
    source_id: Optional[StrictStr] = Field(default=None, alias="sourceId")
    destination_id: Optional[Annotated[str, Field(min_length=5, strict=True, max_length=18)]] = Field(default=None, alias="destinationId")
    concrete_value: Optional[ConcreteValue] = Field(default=None, alias="concreteValue")
    relationship_group: Optional[StrictInt] = Field(default=None, alias="relationshipGroup")
    type_id: Annotated[str, Field(min_length=5, strict=True, max_length=18)] = Field(alias="typeId")
    characteristic_type_id: Annotated[str, Field(min_length=5, strict=True, max_length=18)] = Field(alias="characteristicTypeId")
    modifier_id: Annotated[str, Field(min_length=5, strict=True, max_length=18)] = Field(alias="modifierId")
    source: Optional[ConceptMini] = None
    type: Optional[ConceptMini] = None
    target: Optional[ConceptMini] = None
    concrete: Optional[StrictBool] = None
    group_id: Optional[StrictInt] = Field(default=None, alias="groupId")
    grouped: Optional[StrictBool] = None
    inferred: Optional[StrictBool] = None
    modifier: Optional[StrictStr] = None
    relationship_id_as_long: Optional[StrictInt] = Field(default=None, alias="relationshipIdAsLong")
    characteristic_type: Optional[StrictStr] = Field(default=None, alias="characteristicType")
    effective_time: Optional[StrictStr] = Field(default=None, alias="effectiveTime")
    id: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["internalId", "path", "start", "end", "deleted", "changed", "active", "moduleId", "effectiveTimeI", "released", "releaseHash", "releasedEffectiveTime", "relationshipId", "sourceId", "destinationId", "concreteValue", "relationshipGroup", "typeId", "characteristicTypeId", "modifierId", "source", "type", "target", "concrete", "groupId", "grouped", "inferred", "modifier", "relationshipIdAsLong", "characteristicType", "effectiveTime", "id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Relationship from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of concrete_value
        if self.concrete_value:
            _dict['concreteValue'] = self.concrete_value.to_dict()
        # override the default output from pydantic by calling `to_dict()` of source
        if self.source:
            _dict['source'] = self.source.to_dict()
        # override the default output from pydantic by calling `to_dict()` of type
        if self.type:
            _dict['type'] = self.type.to_dict()
        # override the default output from pydantic by calling `to_dict()` of target
        if self.target:
            _dict['target'] = self.target.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Relationship from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "internalId": obj.get("internalId"),
            "path": obj.get("path"),
            "start": obj.get("start"),
            "end": obj.get("end"),
            "deleted": obj.get("deleted"),
            "changed": obj.get("changed"),
            "active": obj.get("active"),
            "moduleId": obj.get("moduleId"),
            "effectiveTimeI": obj.get("effectiveTimeI"),
            "released": obj.get("released"),
            "releaseHash": obj.get("releaseHash"),
            "releasedEffectiveTime": obj.get("releasedEffectiveTime"),
            "relationshipId": obj.get("relationshipId"),
            "sourceId": obj.get("sourceId"),
            "destinationId": obj.get("destinationId"),
            "concreteValue": ConcreteValue.from_dict(obj["concreteValue"]) if obj.get("concreteValue") is not None else None,
            "relationshipGroup": obj.get("relationshipGroup"),
            "typeId": obj.get("typeId"),
            "characteristicTypeId": obj.get("characteristicTypeId"),
            "modifierId": obj.get("modifierId"),
            "source": ConceptMini.from_dict(obj["source"]) if obj.get("source") is not None else None,
            "type": ConceptMini.from_dict(obj["type"]) if obj.get("type") is not None else None,
            "target": ConceptMini.from_dict(obj["target"]) if obj.get("target") is not None else None,
            "concrete": obj.get("concrete"),
            "groupId": obj.get("groupId"),
            "grouped": obj.get("grouped"),
            "inferred": obj.get("inferred"),
            "modifier": obj.get("modifier"),
            "relationshipIdAsLong": obj.get("relationshipIdAsLong"),
            "characteristicType": obj.get("characteristicType"),
            "effectiveTime": obj.get("effectiveTime"),
            "id": obj.get("id")
        })
        return _obj


