# coding: utf-8

"""
    Snowstorm

    SNOMED CT Terminology Server REST API

    The version of the OpenAPI document: 10.8.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class SnomedComponentObjectComponent(BaseModel):
    """
    SnomedComponentObjectComponent
    """ # noqa: E501
    internal_id: Optional[StrictStr] = Field(default=None, alias="internalId")
    path: Optional[StrictStr] = None
    start: Optional[datetime] = None
    end: Optional[datetime] = None
    deleted: Optional[StrictBool] = None
    changed: Optional[StrictBool] = None
    active: Optional[StrictBool] = None
    module_id: Optional[Annotated[str, Field(min_length=5, strict=True, max_length=18)]] = Field(default=None, alias="moduleId")
    effective_time_i: Optional[StrictInt] = Field(default=None, alias="effectiveTimeI")
    released: Optional[StrictBool] = None
    release_hash: Optional[StrictStr] = Field(default=None, alias="releaseHash")
    released_effective_time: Optional[StrictInt] = Field(default=None, alias="releasedEffectiveTime")
    effective_time: Optional[StrictStr] = Field(default=None, alias="effectiveTime")
    id: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["internalId", "path", "start", "end", "deleted", "changed", "active", "moduleId", "effectiveTimeI", "released", "releaseHash", "releasedEffectiveTime", "effectiveTime", "id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SnomedComponentObjectComponent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SnomedComponentObjectComponent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "internalId": obj.get("internalId"),
            "path": obj.get("path"),
            "start": obj.get("start"),
            "end": obj.get("end"),
            "deleted": obj.get("deleted"),
            "changed": obj.get("changed"),
            "active": obj.get("active"),
            "moduleId": obj.get("moduleId"),
            "effectiveTimeI": obj.get("effectiveTimeI"),
            "released": obj.get("released"),
            "releaseHash": obj.get("releaseHash"),
            "releasedEffectiveTime": obj.get("releasedEffectiveTime"),
            "effectiveTime": obj.get("effectiveTime"),
            "id": obj.get("id")
        })
        return _obj


